| #!/bin/sh |
| |
| # This script is executed when the guest agent receives fsfreeze-freeze and |
| # fsfreeze-thaw commands, provided that the --fsfreeze-hook (-F) option of |
| # qemu-ga is specified and the script is placed in /etc/qemu/fsfreeze-hook or in |
| # the path specified together with -F. When the agent receives fsfreeze-freeze |
| # requests, this script is called with "freeze" as its argument before the |
| # filesystem is frozen. And for fsfreeze-thaw requests, it is called with "thaw" |
| # as its argument after the filesystem is thawed. |
| |
| LOGFILE=/var/log/qga-fsfreeze-hook.log |
| FSFREEZE_D=$(dirname -- "$0")/fsfreeze-hook.d |
| |
| # Check whether file $1 is a backup or rpm-generated file and should be ignored |
| is_ignored_file() { |
| case "$1" in |
| *~ | *.bak | *.orig | *.rpmnew | *.rpmorig | *.rpmsave | *.sample | *.dpkg-old | *.dpkg-new | *.dpkg-tmp | *.dpkg-dist | *.dpkg-bak | *.dpkg-backup | *.dpkg-remove) |
| return 0 ;; |
| esac |
| return 1 |
| } |
| |
| USE_SYSLOG=0 |
| # if log file exists but is not writable, fallback to syslog |
| [ -e "$LOGFILE" ] && [ ! -w "$LOGFILE" ] && USE_SYSLOG=1 |
| # try to update log file and fallback to syslog if it fails |
| touch "$LOGFILE" >/dev/null 2>&1 || USE_SYSLOG=1 |
| |
| # Ensure the log file is writable, fallback to syslog if not |
| log_message() { |
| if [ "$USE_SYSLOG" -eq 0 ]; then |
| printf "%s: %s\n" "$(date)" "$1" >>"$LOGFILE" |
| else |
| logger -t qemu-ga-freeze-hook "$1" |
| fi |
| } |
| |
| # Iterate executables in directory "fsfreeze-hook.d" with the specified args |
| [ ! -d "$FSFREEZE_D" ] && exit 0 |
| |
| for file in "$FSFREEZE_D"/* ; do |
| is_ignored_file "$file" && continue |
| [ -x "$file" ] || continue |
| |
| log_message "Executing $file $*" |
| if [ "$USE_SYSLOG" -eq 0 ]; then |
| "$file" "$@" >>"$LOGFILE" 2>&1 |
| STATUS=$? |
| else |
| # We want to pipe the output of $file through 'logger' and also |
| # capture its exit status. Since we are a POSIX script we can't |
| # use PIPESTATUS, so instead this is a trick borrowed from |
| # https://unix.stackexchange.com/questions/14270/get-exit-status-of-process-thats-piped-to-another/70675#70675 |
| # which uses command-groups and redirection to get the exit status. |
| # This is equivalent to |
| # "$file" "$@" 2>&1 | logger -t qemu-ga-freeze-hook |
| # plus setting the exit status of the pipe to the exit |
| # status of the first command rather than the last one. |
| { { { { |
| "$file" "$@" 2>&1 3>&- 4>&- |
| echo $? >&3 |
| } | logger -t qemu-ga-freeze-hook >&4 |
| } 3>&1 |
| } | { read -r xs ; exit "$xs"; } |
| } 4>&1 |
| STATUS=$? |
| fi |
| |
| if [ "$STATUS" -ne 0 ]; then |
| log_message "Error: $file finished with status=$STATUS" |
| else |
| log_message "$file finished successfully" |
| fi |
| done |
| |
| exit 0 |